/* Problem URL: https://codeforces.com/problemset/problem/474/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vi fds(n);
    cin >> fds;

    vvi sparse(20, vi(n));

    rep(i, n) {
        sparse[0][i] = fds[i];
    }

    nrep(j, 1, 20) {
        rep(i, n - (1 << (j - 1))) {
            sparse[j][i] = __gcd(sparse[j - 1][i], sparse[j - 1][i + (1 << (j - 1))]);
        }
    }

    auto squery = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);
        return __gcd(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    };

    while (__builtin_popcount(n) != 1) {
        n++;
        fds.push_back(1);
    }

    vvi seg(n * 2);

    nrep(i, n, n * 2) {
        seg[i] = {fds[i - n]};
    }

    for (int i = n - 1; i > 0; i--) {
        merge(all(seg[i * 2]), all(seg[i * 2 + 1]), back_inserter(seg[i]));
    }

    function<int(int, int, int, int, int, int)> query = [&](int i, int l, int r, int tl, int tr, int v) -> int {
        if (l > tr || r < tl) {
            return 0;
        }

        if (l >= tl && r <= tr) {
            return upper_bound(all(seg[i]), v) - lower_bound(all(seg[i]), v);
        }

        int mid = (l + r) >> 1;

        return query(i * 2, l, mid, tl, tr, v) + query(i * 2 + 1, mid + 1, r, tl, tr, v);
    };

    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        cout << (r - l + 1) - query(1, 0, n - 1, l, r, squery(l, r)) << '\n';
    }
}
